"use strict";

var _ = require("..");

var _hooks = _interopRequireDefault(require("../hooks"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

jest.mock("../hooks", () => ({
  __esModule: true,
  default: jest.fn()
}));
describe('useFilters custom hook', () => {
  it('should format search string', () => {
    (0, _.useFilters)({
      fields: ['foo', 'bar', 'quux'],
      coll: 'demo'
    });
    expect(_hooks.default).toHaveBeenCalledWith(expect.objectContaining({
      url: '/search?coll=demo&fields[]=foo&fields[]=bar&fields[]=quux'
    }));
  });
  it('should append query string', () => {
    (0, _.useFilters)({
      query: '?search=hi',
      fields: ['foo'],
      coll: 'demo'
    });
    expect(_hooks.default).toHaveBeenCalledWith(expect.objectContaining({
      url: '/search?coll=demo&fields[]=foo&search=hi'
    }));
  });
  it('should create a drop-down options list', () => {
    _hooks.default.mockReturnValue({
      fields: {
        example: ['foo', 'bar']
      }
    });

    const filters = (0, _.useFilters)({
      fields: ['foo'],
      coll: 'demo'
    });
    expect(filters.getOptions('example')).toEqual([{
      label: 'foo',
      value: 'foo'
    }, {
      label: 'bar',
      value: 'bar'
    }]);
  });
});